def call(body) {
  def pipelineParams= [:]
  body.resolveStrategy = Closure.DELEGATE_FIRST
  body.delegate = pipelineParams
  body()

  pipeline {
    agent any
    environment {
      def shortCommit = sh(returnStdout: true, script: "git log -n 1 --pretty=format:'%h'").trim()
      def GIT_DEVOPS_PWD = "${pipelineParams.GIT_DEVOPS_PWD}"
      def GIT_DEVOPS_USER = "${pipelineParams.GIT_DEVOPS_USER}"
      def APP_STACK = "${pipelineParams.APP_STACK}"
      def MAVEN_PROFILE = "${pipelineParams.MAVEN_PROFILE}"
      def APP_PLATFORM = "${pipelineParams.APP_PLATFORM}"
      def APP_ID = "${pipelineParams.APP_ID}"
      def APP_NAME = "${pipelineParams.appName}"
      def NO_VALUES_FILE = "${pipelineParams.NO_VALUES_FILE}"
      SLACK_CHANNEL_NOTIF = "${pipelineParams.slackChannelNotification}"
    }
    stages {
      stage('build start') {
        steps {
          script {
            slackSend(
              channel: SLACK_CHANNEL_NOTIF,
              color: '#45b6fe',
              message: "Build Started: ${currentBuild.fullDisplayName}"
            )
          }
        }
      }
      stage('checkout') {
        steps {
          checkout scm
        }
      }
      stage('Build') {
        steps {
          echo 'Building..'
            }
        }

        stage('Test') {
          steps {
            echo 'Testing..'
            }
        }

        stage('Build image') {
          steps {
            sh "docker build -t baamtu/docker-demo:master ."


                }
            }


        stage('Push image') {
          steps {
            sh "docker push baamtu/docker-demo:master"


                }
            }
}

}